/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: 11 Steps

     Minimalistic examples to build upon and experiment with 
	 to develop an understanding of the underlying API

	   
/*
/****************************************************************/

// Fragement Shader or sometimes called the 
// `pixel shader'
// shader version
#version 420

// input (from our vertex shader above)
layout ( location = 0 ) in vec4 inColor;
layout ( location = 1 ) in vec2 inTexCoords;

layout ( binding = 1 ) uniform sampler2D inTexSampler;

// final screen output color
layout ( location = 0 ) out vec4 outFragColor;

vec4 lumcoeff = vec4(0.299, 0.587, 0.114, 0);

// shader entry point
void main() 
{
  vec4 col = texture(inTexSampler, inTexCoords.xy);
  float lum = dot(col, lumcoeff);

  // set a hard binary black-white step
  if (0.8 < lum) 
  {
    outFragColor = vec4(1, 1, 1, 1);
  } 
  else 
  {
    outFragColor = vec4(0, 0, 0, 1);
  }

  // gray scale output
  // outFragColor = vec4(lum, lum, lum, 1);
  

  // Original non-blurred texture output
  // outFragColor = texture(inTexSampler, inTexCoords);

  // fixed color from vertices
  // outFragColor = inColor;

}// End main(..)