/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: 11 Steps

     Minimalistic examples to build upon and experiment with 
	 to develop an understanding of the underlying API

	   
/*
/****************************************************************/

// Vertex Shader
// shader version
#version 420


// input matrix transforms (3D) passed in from our program
layout ( std140, set = 0, binding = 0 ) uniform buffer 
{
  mat4 inProjectionMatrix;
  mat4 inViewMatrix;
  mat4 inModelMatrix;
};

// input from your program
layout( location = 0 ) in vec4 inPos;
layout( location = 1 ) in vec3 inColor;
layout( location = 2 ) in vec2 inTexCoords;

// output to fragment shader
layout( location = 0 ) out vec4 outColor;
layout( location = 1 ) out vec2 outTexCoords;

// shader entry point
void main() 
{	
  // combine the matrices
  mat4 modelView = inModelMatrix * inViewMatrix;

  // transform position by matrices
  gl_Position = inPos * ( modelView * inProjectionMatrix );

  // pass onto the next stage
  outColor     = vec4(inColor, 1.0);
  outTexCoords = inTexCoords;

}// End main(..)